Module SQL_倉儲系統管理
    Friend Sub SQL_新物料群組()
        ConnOpen()
        SQL1 = "SELECT     物料新群組.編號, 物料新群組.語言, 物料新群組.第一層, 物料新群組.第二層, 物料新群組.第三層, 物料新群組.第四層, 
                           物料新群組.第五層, COUNT(物料編碼庫.新群組碼) AS 資料數
                FROM       物料新群組 LEFT OUTER JOIN
                           物料編碼庫 ON 物料新群組.編號 = 物料編碼庫.新群組碼
                WHERE     (物料新群組.語言 LIKE N'" & 系統語言 & "')
                GROUP BY   物料新群組.編號, 物料新群組.語言, 物料新群組.第一層, 物料新群組.第二層, 物料新群組.第三層, 物料新群組.第四層, 
                           物料新群組.第五層
                ORDER BY   物料新群組.第一層, 物料新群組.第二層, 物料新群組.第三層, 物料新群組.第四層, 物料新群組.第五層"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表_新群組()
        ConnOpen()
        If 低網速模式 = False Then : SQL3 = ", 物料圖庫.圖檔 AS Image" : Else : SQL3 = "" : End If
        SQL1 = "SELECT      物料資訊控制表.群組碼, 物料資訊控制表.料號原則, 物料編碼庫轉語言.品名, 
                            物料編碼庫.新群組碼 AS Keyword, 物料資訊控制表.規格庫抬頭指定, 物料編碼庫.單位, 
                            物料圖庫.圖片流水號 AS [Image No]" & SQL3 & "
                FROM        物料資訊控制表 INNER JOIN 物料編碼庫 ON 物料資訊控制表.群組碼 = 物料編碼庫.群組碼 AND 物料資訊控制表.料號原則 = 物料編碼庫.料號原則 INNER JOIN
                            物料圖庫 ON 物料資訊控制表.群組碼 = 物料圖庫.群組碼 AND 物料資訊控制表.料號原則 = 物料圖庫.料號原則 INNER JOIN
                            物料編碼庫轉語言 ON 物料編碼庫.料號原則 = 物料編碼庫轉語言.料號原則 " & SQL2 & "
                ORDER BY    物料資訊控制表.群組碼, 物料編碼庫轉語言.品名"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料群組_倉儲()
        ConnOpen()
        SQL1 = "SELECT     物料群組轉語言.群組碼, 物料群組轉語言.群組
                FROM       物料群組轉語言 INNER JOIN 物料群組 ON 物料群組轉語言.群組碼 = 物料群組.群組碼
                WHERE     (物料群組轉語言.主項 LIKE '%%') AND (物料群組轉語言.語言 LIKE '" & 系統語言 & "')
                ORDER BY   物料群組轉語言.群組碼"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼清單1()
        ConnOpen()
        SQL1 = "SELECT    物料群組.群組碼
                FROM      物料群組 INNER JOIN 物料群組轉語言 ON 物料群組.群組碼 = 物料群組轉語言.群組碼
                WHERE    (物料群組轉語言.主項 LIKE N'%" & PA49 & "%')
                GROUP BY  物料群組.群組碼  ORDER BY  物料群組.群組碼"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼清單_含語言1()
        ConnOpen()
        SQL1 = "SELECT  群組碼, 群組, 主項 FROM 物料群組轉語言 WHERE 語言 LIKE N'" & 系統語言 & "' AND 主項 LIKE N'%" & PA49 & "%' ORDER BY 群組碼"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_舊群組()
        ConnOpen() : SQL1 = "SELECT  項目  FROM  物料舊分類  WHERE  (編碼 LIKE N'" & PA20 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_比對1()
        ConnOpen()
        SQL1 = "SELECT          QQQ.圖片流水號, QQQ.圖片群組, QQQ.圖片料號, QQQ.編碼群組, QQQ.編碼料號
                FROM            HX空白圖片 FULL OUTER JOIN
                                (SELECT          物料圖庫.圖片流水號, 物料圖庫.群組碼 AS 圖片群組, 物料圖庫.料號原則 AS 圖片料號, 
                                                 物料編碼庫.群組碼 AS 編碼群組, 物料編碼庫.料號原則 AS 編碼料號
                                  FROM           物料編碼庫 FULL OUTER JOIN 物料圖庫 ON 物料編碼庫.料號原則 = 物料圖庫.料號原則
                                  WHERE           (物料圖庫.料號原則 NOT LIKE N'')) AS QQQ ON HX空白圖片.選擇 = QQQ.圖片流水號
                WHERE          (QQQ.圖片群組 IS NULL) OR (QQQ.編碼群組 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對2()
        ConnOpen()
        SQL1 = "SELECT          QQQ.編碼群組, QQQ.編碼料號, QQQ.編碼品名, QQQ.資訊群組, QQQ.資訊料號, QQQ.資訊品名
                FROM            HX空白圖片 FULL OUTER JOIN
                                (SELECT          物料編碼庫.群組碼 AS 編碼群組, 物料編碼庫.料號原則 AS 編碼料號, 
                                                 物料編碼庫.原則說明 AS 編碼品名, 物料資訊控制表.群組碼 AS 資訊群組, 
                                                 物料資訊控制表.料號原則 AS 資訊料號, 物料資訊控制表.品名 AS 資訊品名
                                  FROM           物料編碼庫 FULL OUTER JOIN 物料資訊控制表 ON 物料編碼庫.料號原則 = 物料資訊控制表.料號原則) AS QQQ ON 
                                HX空白圖片.選擇 = QQQ.編碼群組
                WHERE          (QQQ.資訊群組 IS NULL) OR (QQQ.編碼群組 IS NULL) OR (QQQ.編碼品名 <> QQQ.資訊品名)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對3()
        ConnOpen()
        SQL1 = "SELECT     物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 
                           物料編碼庫轉語言.群組碼 AS 語轉群組碼, 物料編碼庫轉語言.料號原則 AS 語轉料號原則, 
                           物料編碼庫轉語言.語言, 物料編碼庫轉語言.品名, 物料規格表.群組碼 AS 規格群組碼, 
                           物料規格表.料號原則 AS 規格料號原則
                FROM       物料規格表 FULL OUTER JOIN
                           物料編碼庫轉語言 ON 物料規格表.料號原則 = 物料編碼庫轉語言.料號原則 FULL OUTER JOIN
                           物料編碼庫 ON 物料編碼庫轉語言.料號原則 = 物料編碼庫.料號原則
                GROUP BY   物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫轉語言.群組碼, 
                           物料編碼庫轉語言.料號原則, 物料編碼庫轉語言.語言, 物料編碼庫轉語言.品名, 物料規格表.群組碼, 
                           物料規格表.料號原則
                HAVING     (物料編碼庫.群組碼 + 物料編碼庫.料號原則 <> 物料編碼庫轉語言.群組碼 + 物料編碼庫轉語言.料號原則) OR
                           (物料編碼庫.群組碼 + 物料編碼庫.料號原則 <> 物料規格表.群組碼 + 物料規格表.料號原則) OR
                           (物料編碼庫轉語言.群組碼 + 物料編碼庫轉語言.料號原則 <> 物料規格表.群組碼 + 物料規格表.料號原則)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對4()
        ConnOpen()
        SQL1 = "SELECT  合約試算明細表.合約編號, 合約試算明細表.料號, 物料規格表.料號 AS 物料庫料號
                FROM    合約試算明細表 LEFT OUTER JOIN 物料規格表 ON 合約試算明細表.料號 = 物料規格表.料號
                WHERE  (物料規格表.料號 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對5()
        ConnOpen()
        SQL1 = "SELECT      物料編碼庫轉語言.群組碼 AS 語轉群組, 物料編碼庫轉語言.料號原則 AS 語轉編碼, 物料編碼庫轉語言.語言, 
                            物料編碼庫轉語言.品名, 物料編碼庫.原則說明, 物料編碼庫.料號原則, 物料編碼庫.群組碼
                FROM        物料編碼庫轉語言 FULL OUTER JOIN
                            物料編碼庫 ON 物料編碼庫轉語言.料號原則 = 物料編碼庫.料號原則 AND 
                            物料編碼庫轉語言.群組碼 = 物料編碼庫.群組碼
                WHERE      (物料編碼庫.原則說明 IS NULL) OR
                           (物料編碼庫轉語言.料號原則 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對6()
        ConnOpen()
        SQL1 = "SELECT  KK.請購使用到的料號 AS 請購表中遺失的料號
                FROM    HX空白圖片 RIGHT OUTER JOIN
                       (SELECT  請購單明細表.料號 AS 請購使用到的料號, QQ.料號 AS 規格料號
                        FROM    請購單明細表 FULL OUTER JOIN
                               (SELECT  料號   FROM  物料規格表  GROUP BY  料號) AS QQ ON 請購單明細表.料號 = QQ.料號
                        GROUP BY    請購單明細表.料號, QQ.料號) AS KK ON HX空白圖片.選擇 = KK.規格料號
                WHERE  (KK.請購使用到的料號 IS NOT NULL) AND (KK.規格料號 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對7()
        ConnOpen()
        SQL1 = "SELECT  KK.採購使用到的料號 AS 採購表中遺失的料號
                FROM    HX空白圖片 RIGHT OUTER JOIN
                       (SELECT  採購單明細表.料號 AS 採購使用到的料號, QQ.料號 AS 規格料號
                        FROM    採購單明細表 FULL OUTER JOIN
                               (SELECT  料號  FROM  物料規格表  GROUP BY  料號) AS QQ ON 採購單明細表.料號 = QQ.料號
                        GROUP BY    採購單明細表.料號, QQ.料號) AS KK ON HX空白圖片.選擇 = KK.規格料號
                WHERE  (KK.規格料號 IS NULL) AND (KK.採購使用到的料號 IS NOT NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對8()
        ConnOpen()
        SQL1 = "SELECT  KK.倉儲使用到的料號 AS 倉儲表中遺失的料號
                FROM    HX空白圖片 RIGHT OUTER JOIN
                       (SELECT  倉儲明細表.料號 AS 倉儲使用到的料號, QQ.料號 AS 規格料號
                        FROM    倉儲明細表 FULL OUTER JOIN
                               (SELECT  料號  FROM  物料規格表  GROUP BY  料號) AS QQ ON 倉儲明細表.料號 = QQ.料號
                        GROUP BY    倉儲明細表.料號, QQ.料號) AS KK ON HX空白圖片.選擇 = KK.規格料號
                WHERE  (KK.倉儲使用到的料號 IS NOT NULL) AND (KK.規格料號 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_比對9()
        ConnOpen()
        SQL1 = "SELECT  KK.合約使用到的料號 AS 合約表中遺失的料號
                FROM    HX空白圖片 RIGHT OUTER JOIN
                       (SELECT  合約報價明細表.料號 AS 合約使用到的料號, QQ.料號 AS 規格料號
                        FROM    合約報價明細表 FULL OUTER JOIN
                               (SELECT  料號  FROM  物料規格表  GROUP BY  料號) AS QQ ON 合約報價明細表.料號 = QQ.料號
                                WHERE  (合約報價明細表.料號 NOT LIKE '')
                        GROUP BY    合約報價明細表.料號, QQ.料號) AS KK ON HX空白圖片.選擇 = KK.規格料號
                WHERE  (KK.合約使用到的料號 IS NOT NULL) AND (KK.規格料號 IS NULL)"
        CmdSet_For_DGV()
    End Sub  'SQL_料號使用
    Friend Sub SQL_料號使用()
        ConnOpen()
        SQL1 = "SELECT          物料規格表.料號, 請購.請購使用到的料號, 採購.採購使用到的料號, 倉儲.倉儲使用到的料號, 
                            合約.合約使用到的料號, 物料規格表.料號 AS 已使用料號
                FROM              物料規格表 LEFT OUTER JOIN
                                (SELECT          KK.合約使用到的料號
                                  FROM               HX空白圖片 RIGHT OUTER JOIN
                                                                  (SELECT          合約報價明細表.料號 AS 合約使用到的料號, QQ.料號 AS 規格料號
                                                                    FROM               合約報價明細表 FULL OUTER JOIN
                                                                                                    (SELECT          料號
                                                                                                      FROM               物料規格表 AS 物料規格表_4
                                                                                                      GROUP BY    料號) AS QQ ON 合約報價明細表.料號 = QQ.料號
                                                                    WHERE           (合約報價明細表.料號 NOT LIKE '')
                                                                    GROUP BY    合約報價明細表.料號, QQ.料號) AS KK ON 
                                                              HX空白圖片.選擇 = KK.規格料號
                                  WHERE           (KK.合約使用到的料號 IS NOT NULL)) AS 合約 ON 
                            物料規格表.料號 = 合約.合約使用到的料號 LEFT OUTER JOIN
                                (SELECT          KK_3.倉儲使用到的料號
                                  FROM               HX空白圖片 AS HX空白圖片_3 RIGHT OUTER JOIN
                                                                  (SELECT          倉儲明細表.料號 AS 倉儲使用到的料號, QQ_3.料號 AS 規格料號
                                                                    FROM               倉儲明細表 FULL OUTER JOIN
                                                                                                    (SELECT          料號
                                                                                                      FROM               物料規格表 AS 物料規格表_3
                                                                                                      GROUP BY    料號) AS QQ_3 ON 倉儲明細表.料號 = QQ_3.料號
                                                                    GROUP BY    倉儲明細表.料號, QQ_3.料號) AS KK_3 ON 
                                                              HX空白圖片_3.選擇 = KK_3.規格料號
                                  WHERE           (KK_3.倉儲使用到的料號 IS NOT NULL)) AS 倉儲 ON 
                            物料規格表.料號 = 倉儲.倉儲使用到的料號 LEFT OUTER JOIN
                                (SELECT          KK_2.採購使用到的料號
                                  FROM               HX空白圖片 AS HX空白圖片_2 RIGHT OUTER JOIN
                                                                  (SELECT          採購單明細表.料號 AS 採購使用到的料號, QQ_2.料號 AS 規格料號
                                                                    FROM               採購單明細表 FULL OUTER JOIN
                                                                                                    (SELECT          料號
                                                                                                      FROM               物料規格表 AS 物料規格表_2
                                                                                                      GROUP BY    料號) AS QQ_2 ON 採購單明細表.料號 = QQ_2.料號
                                                                    GROUP BY    採購單明細表.料號, QQ_2.料號) AS KK_2 ON 
                                                              HX空白圖片_2.選擇 = KK_2.規格料號
                                  WHERE           (KK_2.採購使用到的料號 IS NOT NULL)) AS 採購 ON 
                            物料規格表.料號 = 採購.採購使用到的料號 LEFT OUTER JOIN
                                (SELECT          KK_1.請購使用到的料號
                                  FROM               HX空白圖片 AS HX空白圖片_1 RIGHT OUTER JOIN
                                                                  (SELECT          請購單明細表.料號 AS 請購使用到的料號, QQ_1.料號 AS 規格料號
                                                                    FROM               請購單明細表 FULL OUTER JOIN
                                                                                                    (SELECT          料號
                                                                                                      FROM               物料規格表 AS 物料規格表_1
                                                                                                      GROUP BY    料號) AS QQ_1 ON 請購單明細表.料號 = QQ_1.料號
                                                                    GROUP BY    請購單明細表.料號, QQ_1.料號) AS KK_1 ON 
                                                              HX空白圖片_1.選擇 = KK_1.規格料號
                                  WHERE           (KK_1.請購使用到的料號 IS NOT NULL)) AS 請購 ON 
                            物料規格表.料號 = 請購.請購使用到的料號
                ORDER BY   物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫()
        ConnOpen()   ', 物料圖庫.圖檔 AS Image
        If BL1 = False Then
            If 精準 = False Then
                If PA1 = "" Then
                    SQL2 = "WHERE  (物料編碼庫.群組碼 LIKE N'" & PA & "')"
                    SQL1 = "SELECT    物料編碼庫.群組碼 AS 項次, 物料編碼庫.料號原則, 物料編碼庫.原則說明 AS 物料品名, 物料編碼庫.單位, HX選擇按鈕.選擇, 
                              物料圖庫.圖片流水號 AS [Image No], 物料編碼庫.群組碼, HX選擇按鈕.選擇 AS 存檔,
                              物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                    FROM      物料編碼庫 LEFT OUTER JOIN
                              物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 
                              物料編碼庫.料號原則 = 物料資訊控制表.料號原則 LEFT OUTER JOIN
                              HX選擇按鈕 ON 物料編碼庫.群組碼 = HX選擇按鈕.對應 LEFT OUTER JOIN
                              物料圖庫 ON 物料編碼庫.群組碼 = 物料圖庫.群組碼 AND 物料編碼庫.料號原則 = 物料圖庫.料號原則 " & SQL2 & "
                    ORDER BY 物料編碼庫.料號原則"
                Else
                    SQL2 = "WHERE    (物料編碼庫.原則說明 LIKE N'%" & PA1 & "%') OR (物料規格表.A1 LIKE N'%" & PA1 & "%') OR (物料規格表.A2 LIKE N'%" & PA1 & "%') OR
                                 (物料規格表.A3 LIKE N'%" & PA1 & "%') OR (物料規格表.A4 LIKE N'%" & PA1 & "%') OR (物料規格表.A5 LIKE N'%" & PA1 & "%') OR
                                 (物料規格表.A6 LIKE N'%" & PA1 & "%') OR (物料規格表.A7 LIKE N'%" & PA1 & "%') OR (物料規格表.A8 LIKE N'%" & PA1 & "%') OR 
                                 (物料編碼庫.料號原則 LIKE N'" & PA1 & "%')"
                    SQL1 = "SELECT    QQ.項次, QQ.料號原則, QQ.原則說明 AS 物料品名, QQ.單位, QQ.選擇, 物料圖庫.圖片流水號 AS [Image No], 
                                  QQ.群組碼, QQ.存檔, QQ.規格庫編號, QQ.規格庫抬頭指定
                        FROM      物料圖庫 RIGHT OUTER JOIN
                                 (SELECT    物料編碼庫.群組碼 AS 項次, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, 
                                            HX選擇按鈕.選擇 AS 存檔, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                                  FROM      物料編碼庫 LEFT OUTER JOIN 物料規格表 ON 物料編碼庫.群組碼 = 物料規格表.群組碼 AND 物料編碼庫.料號原則 = 物料規格表.料號原則 LEFT OUTER JOIN
                                            物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 物料編碼庫.料號原則 = 物料資訊控制表.料號原則 LEFT OUTER JOIN
                                            HX選擇按鈕 ON 物料編碼庫.群組碼 = HX選擇按鈕.對應 " & SQL2 & "
                                  GROUP BY  物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, HX選擇按鈕.選擇, 
                                            物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定) AS QQ ON 物料圖庫.料號原則 = QQ.料號原則 AND 物料圖庫.群組碼 = QQ.群組碼
                                  ORDER BY  QQ.料號原則"
                End If
            Else
                SQL2 = "WHERE    (物料編碼庫.料號原則 LIKE N'" & PA1 & "%')"
                SQL1 = "SELECT    QQ.項次, QQ.料號原則, QQ.原則說明 AS 物料品名, QQ.單位, QQ.選擇, 物料圖庫.圖片流水號 AS [Image No], 
                                  QQ.群組碼, QQ.存檔, QQ.規格庫編號, QQ.規格庫抬頭指定
                        FROM      物料圖庫 RIGHT OUTER JOIN
                                 (SELECT    物料編碼庫.群組碼 AS 項次, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, 
                                            HX選擇按鈕.選擇 AS 存檔, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                                  FROM      物料編碼庫 LEFT OUTER JOIN 物料規格表 ON 物料編碼庫.群組碼 = 物料規格表.群組碼 AND 物料編碼庫.料號原則 = 物料規格表.料號原則 LEFT OUTER JOIN
                                            物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 物料編碼庫.料號原則 = 物料資訊控制表.料號原則 LEFT OUTER JOIN
                                            HX選擇按鈕 ON 物料編碼庫.群組碼 = HX選擇按鈕.對應 " & SQL2 & "
                                  GROUP BY  物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, HX選擇按鈕.選擇, 
                                            物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定) AS QQ ON 物料圖庫.料號原則 = QQ.料號原則 AND 物料圖庫.群組碼 = QQ.群組碼
                                  ORDER BY  QQ.料號原則"
            End If
        Else
            SQL1 = "SELECT    物料編碼庫.群組碼 AS 項次, 物料編碼庫.料號原則, 物料編碼庫.原則說明 AS 物料品名, 物料編碼庫.單位, HX選擇按鈕.選擇, 
                              物料圖庫.圖片流水號 AS [Image No], 物料編碼庫.群組碼, HX選擇按鈕.選擇 AS 存檔, 
                              物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                    FROM      物料編碼庫 LEFT OUTER JOIN
                              物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 
                              物料編碼庫.料號原則 = 物料資訊控制表.料號原則 LEFT OUTER JOIN
                              HX選擇按鈕 ON 物料編碼庫.群組碼 = HX選擇按鈕.對應 LEFT OUTER JOIN
                              物料圖庫 ON 物料編碼庫.群組碼 = 物料圖庫.群組碼 AND 物料編碼庫.料號原則 = 物料圖庫.料號原則
                    WHERE    (物料圖庫.圖片流水號 LIKE N'%%') OR
                             (物料圖庫.圖片流水號 IS NULL)
                    ORDER BY  物料編碼庫.料號原則"
        End If : PA1 = ""
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫_語轉()
        ConnOpen()
        SQL1 = "SELECT 群組碼, 料號原則, 語言, 品名 FROM 物料編碼庫轉語言 WHERE  (群組碼 LIKE N'" & PA & "') ORDER BY 料號原則"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_規格庫抬頭讀取三()
        ConnOpen()
        SQL1 = "SELECT 規格庫抬頭指定, A1, A2, A3, A4, A5, A6, A7, A8, 語言 AS LG FROM  規格庫抬頭 WHERE 語言 LIKE N'" & 系統語言 & "' ORDER BY 規格庫抬頭指定, 語言 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表()
        If BL1 = False Then
            SQL2 = " WHERE       物料資訊控制表.規格庫抬頭指定 LIKE N'" & PA & "'  AND (物料編碼庫轉語言.語言 LIKE N'" & 系統語言 & "') "
        ElseIf BL1 = True Then
            SQL2 = " WHERE       物料資訊控制表.群組碼 LIKE N'" & PA1 & "'  AND (物料編碼庫轉語言.語言 LIKE N'" & 系統語言 & "') "
        End If
        ConnOpen()
        SQL1 = "SELECT      物料資訊控制表.群組碼 , 物料資訊控制表.料號原則, 物料編碼庫轉語言.品名, 
                            物料資訊控制表.規格庫編號 AS Keyword, 物料資訊控制表.規格庫抬頭指定, 物料編碼庫.單位, 
                            物料圖庫.圖片流水號 AS [Image No], 物料圖庫.圖檔 AS Image
                FROM        物料資訊控制表 INNER JOIN 物料編碼庫 ON 物料資訊控制表.群組碼 = 物料編碼庫.群組碼 AND 物料資訊控制表.料號原則 = 物料編碼庫.料號原則 INNER JOIN
                            物料圖庫 ON 物料資訊控制表.群組碼 = 物料圖庫.群組碼 AND 物料資訊控制表.料號原則 = 物料圖庫.料號原則 INNER JOIN
                            物料編碼庫轉語言 ON 物料編碼庫.料號原則 = 物料編碼庫轉語言.料號原則 " & SQL2 & "
                ORDER BY    物料資訊控制表.料號原則"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表未新增()
        ConnOpen()
        SQL1 = "SELECT     物料編碼庫.群組碼, 物料編碼庫.料號原則 , 物料編碼庫.原則說明, 
                           物料資訊控制表.群組碼, 物料資訊控制表.料號原則
                FROM       物料編碼庫 FULL OUTER JOIN 物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 物料編碼庫.料號原則 = 
                           物料資訊控制表.料號原則
                GROUP BY   物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料資訊控制表.群組碼, 物料資訊控制表.料號原則
                HAVING    (物料資訊控制表.群組碼 IS NULL) OR (物料資訊控制表.料號原則 IS NULL)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資訊控制表_規格庫抬頭指定()
        ConnOpen() : SQL1 = "SELECT 規格庫抬頭指定 FROM 規格庫抬頭 GROUP BY 規格庫抬頭指定 ORDER BY 規格庫抬頭指定" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_群組碼_下拉清單()
        ConnOpen() : SQL1 = "SELECT  群組碼 FROM 物料群組 ORDER BY 群組碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_群組碼_語轉_下拉清單1()
        ConnOpen() : SQL1 = "SELECT  群組 FROM 物料群組轉語言 WHERE 語言 LIKE N'" & 系統語言 & "' AND (主項 LIKE N'" & PA49 & "') ORDER BY 群組碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_群組碼_語轉_下拉清單()
        ConnOpen() : SQL1 = "SELECT  群組 FROM 物料群組轉語言 WHERE 語言 LIKE N'" & 系統語言 & "' ORDER BY 群組碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組下拉1()
        ConnOpen() : SQL1 = "SELECT  第一層  FROM  物料新群組  WHERE  (語言 LIKE '" & PA30 & "')  GROUP BY   第一層  ORDER BY   第一層" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組下拉2()
        ConnOpen()
        SQL1 = "SELECT  第二層  FROM  物料新群組  WHERE  (語言 LIKE '" & PA30 & "') AND (第一層 LIKE N'" & PA31 & "')  GROUP BY   第二層  ORDER BY   第二層"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組下拉3()
        ConnOpen()
        SQL1 = "SELECT  第三層  FROM  物料新群組  WHERE  (語言 LIKE '" & PA30 & "') AND (第一層 LIKE N'" & PA31 & "') AND (第二層 LIKE N'" & PA32 & "')  GROUP BY   第三層  ORDER BY   第三層"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組下拉4()
        ConnOpen()
        SQL1 = "SELECT  第四層  FROM  物料新群組  
                WHERE  (語言 LIKE '" & PA30 & "') AND (第一層 LIKE N'" & PA31 & "') AND (第二層 LIKE N'" & PA32 & "') AND (第三層 LIKE N'" & PA33 & "')  GROUP BY   第四層  ORDER BY   第四層"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組下拉5()
        ConnOpen()
        SQL1 = "SELECT     第五層  FROM  物料新群組  
                WHERE     (語言 LIKE '" & PA30 & "') AND (第一層 LIKE N'" & PA31 & "') AND (第二層 LIKE N'" & PA32 & "') AND (第三層 LIKE N'" & PA33 & "') AND (第四層 LIKE N'" & PA34 & "')  
                GROUP BY   第五層  ORDER BY   第五層"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修正1()
        ConnOpen() : SQL1 = "UPDATE 物料規格表 SET 最高庫存量 = 999 WHERE (最高庫存量 = 0)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資訊控制表_原則查詢()
        ConnOpen() : SQL1 = "SELECT 品名, 群組碼, 料號原則, 規格庫編號, 規格庫抬頭指定 FROM 物料資訊控制表 WHERE 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_規格庫抬頭讀取()
        ConnOpen() : SQL1 = "SELECT 規格庫抬頭指定, A1, A2, A3, A4, A5, A6, A7, A8 FROM 規格庫抬頭 WHERE 規格庫抬頭指定 LIKE N'" & PA3 & "' AND 語言 LIKE N'" & 系統語言 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_物料清單()
        ConnOpen()
        If PA = "SQLB03" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4, A5, A6, A7, A8, 最低庫存量, 料號 AS 原始料號, 最高庫存量, 群組碼 AS No, S1, S2, S3, S4, 
                           S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        ElseIf PA = "SQLB04" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4 AS [" & PA7 & "], A5, A6, A7, A8, 最低庫存量, 料號 AS 原始料號, 最高庫存量, 
                           群組碼 AS No, S1, S2, S3, S4, S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        ElseIf PA = "SQLB05" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4 AS [" & PA7 & "], A5 AS [" & PA8 & "], A6, A7, A8, 最低庫存量, 料號 AS 原始料號, 最高庫存量, 
                           群組碼 AS No, S1, S2, S3, S4, S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        ElseIf PA = "SQLB06" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4 AS [" & PA7 & "], A5 AS [" & PA8 & "], A6 AS [" & PA9 & "], A7, A8, 最低庫存量, 料號 AS 原始料號, 
                           最高庫存量, 群組碼 AS No, S1, S2, S3, S4, S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        ElseIf PA = "SQLB07" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4 AS [" & PA7 & "], A5 AS [" & PA8 & "], A6 AS [" & PA9 & "], A7 AS [" & PA10 & "], 
                           A8, 最低庫存量, 料號 AS 原始料號, 最高庫存量, 群組碼 AS No, S1, S2, S3, S4, S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        ElseIf PA = "SQLB08" Then
            SQL1 = "SELECT 群組碼, 料號原則, 料號, 圖檔編號, A1 AS [" & PA4 & "], A2 AS [" & PA5 & "], A3 AS [" & PA6 & "], 
                           A4 AS [" & PA7 & "], A5 AS [" & PA8 & "], A6 AS [" & PA9 & "], A7 AS [" & PA10 & "], 
                           A8 AS [" & PA11 & "], 最低庫存量, 料號 AS 原始料號, 最高庫存量, 群組碼 AS No, S1, S2, S3, S4, S5, S6, S7, S8
                    FROM 物料規格表 
                    WHERE (料號原則 LIKE N'" & PA2 & "') AND (群組碼 LIKE N'" & PA1 & "') ORDER BY 料號"
        End If
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_新物料群組_讀取_中()
        ConnOpen() : SQL1 = "SELECT  編號, 語言, 第一層, 第二層, 第三層, 第四層, 第五層  FROM  物料新群組 WHERE  (語言 LIKE '繁體中文') AND (編號 LIKE '" & PA48 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_讀取_英()
        ConnOpen() : SQL1 = "SELECT  編號, 語言, 第一層, 第二層, 第三層, 第四層, 第五層  FROM  物料新群組 WHERE  (語言 LIKE 'English') AND (編號 LIKE '" & PA48 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_讀取_印()
        ConnOpen() : SQL1 = "SELECT  編號, 語言, 第一層, 第二層, 第三層, 第四層, 第五層  FROM  物料新群組 WHERE  (語言 LIKE 'Indonesian') AND (編號 LIKE '" & PA48 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖檔讀取()
        ConnOpen() : SQL1 = "SELECT 圖檔 FROM 物料圖庫 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則  LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫語言選定()
        ConnOpen() : SQL1 = "SELECT 語言, 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' ORDER BY 語言" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉1()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & 物料資料庫.群組碼_tb.Text & "', '繁體中文', N'" & 物料資料庫.類別1_tb.Text & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉2()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & 物料資料庫.群組碼_tb.Text & "', 'Indonesian', N'" & 物料資料庫.類別3_tb.Text & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉3()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & 物料資料庫.群組碼_tb.Text & "', 'English', N'" & 物料資料庫.類別2_tb.Text & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉11()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & PA20 & "', '繁體中文', N'" & PA20 & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉21()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & PA20 & "', 'Indonesian', N'" & PA20 & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼_語轉31()
        SQL1 = "INSERT INTO 物料群組轉語言 (群組碼, 語言, 群組, 主項) VALUES (N'" & PA20 & "', 'English', N'" & PA20 & "', N'" & PA49 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼刪除_語轉()
        SQL1 = "DELETE FROM 物料群組轉語言 WHERE (群組碼 = N'" & 物料資料庫.群組碼_tb.Text & "')"
    End Sub
    Friend Sub SQL_物料圖庫_群組圖檔()
        ConnOpen() : SQL1 = "SELECT  圖片  FROM  物料群組  WHERE  (群組碼 LIKE '" & PA49 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_群組碼_語轉_選擇()
        ConnOpen() : SQL1 = "SELECT  群組碼 FROM 物料群組轉語言 WHERE 語言 LIKE N'" & 系統語言 & "' AND 群組 = N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢()
        SQL1 = "SELECT 群組碼 FROM 物料群組 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢1()
        SQL1 = "SELECT 群組碼 FROM 物料群組 WHERE 群組碼 LIKE N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉1()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'繁體中文' AND 群組 = N'" & 物料資料庫.類別1_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉2()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'Indonesian' AND 群組 = N'" & 物料資料庫.類別3_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉3()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'English' AND 群組 = N'" & 物料資料庫.類別2_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉1_1()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & PA20 & "' AND 語言 LIKE N'繁體中文' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉2_1()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & PA20 & "' AND 語言 LIKE N'Indonesian' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉3_1()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 LIKE N'" & PA20 & "' AND 語言 LIKE N'English' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼()
        SQL1 = "INSERT INTO 物料群組 (群組碼) VALUES (N'" & 物料資料庫.群組碼_tb.Text & "')"
    End Sub
    Friend Sub SQL_物料資料庫_新增群組碼1()
        SQL1 = "INSERT INTO 物料群組 (群組碼) VALUES (N'" & PA20 & "')"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反1()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'繁體中文' AND 群組 = N'" & 物料資料庫.類別1_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反2()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'Indonesian' AND 群組 = N'" & 物料資料庫.類別3_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反3()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'English' AND 群組 = N'" & 物料資料庫.類別2_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反11()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & PA20 & "' AND 語言 LIKE N'繁體中文' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反21()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & PA20 & "' AND 語言 LIKE N'Indonesian' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼重複查詢_語轉反31()
        SQL1 = "SELECT 群組 FROM 物料群組轉語言 WHERE 群組碼 NOT LIKE N'" & PA20 & "' AND 語言 LIKE N'English' AND 群組 = N'" & PA20 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_1()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & 物料資料庫.類別1_tb.Text & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'繁體中文'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_2()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & 物料資料庫.類別3_tb.Text & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'Indonesian'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_3()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & 物料資料庫.類別2_tb.Text & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "' AND 語言 LIKE N'English'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_11()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & PA & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 語言 LIKE N'繁體中文'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_21()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & PA & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 語言 LIKE N'Indonesian'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改0_31()
        SQL1 = "UPDATE 物料群組轉語言 SET 群組碼 = N'" & PA & "', 群組 = N'" & PA & "', 主項 = N'" & PA49 & "'
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 語言 LIKE N'English'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改1()
        SQL1 = "UPDATE 物料群組 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改2()
        SQL1 = "UPDATE 請購單明細表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改3()
        SQL1 = "UPDATE 物料編碼庫 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_自動修正單位()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫 SET 單位 = N'PCS' WHERE 單位 LIKE N'' OR 單位 IS NULL" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改4()
        SQL1 = "UPDATE 物料圖庫 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改5()
        SQL1 = "UPDATE 物料資訊控制表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改6()
        SQL1 = "UPDATE 物料規格表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改7()
        SQL1 = "UPDATE 採購單明細表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改8()
        SQL1 = "UPDATE  物料編碼庫轉語言  SET  群組碼 = N'" & PA & "'  WHERE  群組碼 LIKE N'" & 物料資料庫.群組碼_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改11()
        SQL1 = "UPDATE 物料群組 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改21()
        SQL1 = "UPDATE 請購單明細表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改31()
        SQL1 = "UPDATE 物料編碼庫 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改41()
        SQL1 = "UPDATE 物料圖庫 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改51()
        SQL1 = "UPDATE 物料資訊控制表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改61()
        SQL1 = "UPDATE 物料規格表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改71()
        SQL1 = "UPDATE 採購單明細表 SET 群組碼 = N'" & PA & "' WHERE 群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼修改81()
        SQL1 = "UPDATE  物料編碼庫轉語言  SET  群組碼 = N'" & PA & "'  WHERE  群組碼 LIKE N'" & PA3 & "'"
    End Sub
    Friend Sub SQL_物料資料庫_群組碼刪除()
        SQL1 = "DELETE FROM 物料群組 WHERE (群組碼 = N'" & 物料資料庫.群組碼_tb.Text & "')"
    End Sub
    Friend Sub SQL_物料圖庫_圖檔讀取三()
        ConnOpen() : SQL1 = "SELECT 圖檔 FROM 物料圖庫 WHERE 圖片流水號 LIKE N'" & PA3 & "'" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料圖庫_圖檔讀取四()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 物料群組 WHERE 群組碼 LIKE N'" & PA3 & "'" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改1()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改2()
        ConnOpen() : SQL1 = "UPDATE 物料資訊控制表 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改3()
        ConnOpen() : SQL1 = "UPDATE 物料圖庫 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改4()
        ConnOpen() : SQL1 = "UPDATE 物料規格表 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改5()
        ConnOpen() : SQL1 = "UPDATE 採購單明細表 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改6()
        ConnOpen() : SQL1 = "UPDATE 請購單明細表 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 群組原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_群組碼批量修改_語轉1()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫轉語言 SET 群組碼 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫重複確認()
        ConnOpen() : SQL1 = "SELECT 群組碼, 料號原則, 原則說明 FROM 物料編碼庫 WHERE 料號原則 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫新增()
        ConnOpen() : SQL1 = "INSERT INTO 物料編碼庫 (群組碼, 料號原則, 原則說明, 單位) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA3 & "', N'" & PA4 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫語轉重複確認()
        ConnOpen() : SQL1 = "SELECT 群組碼 FROM 物料編碼庫轉語言 WHERE 料號原則 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫新增_語轉1()
        ConnOpen() : SQL1 = "INSERT INTO 物料編碼庫轉語言 (群組碼, 料號原則, 語言, 品名) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'繁體中文', N'" & 物料資料庫.品名1_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫新增_語轉2()
        ConnOpen() : SQL1 = "INSERT INTO 物料編碼庫轉語言 (群組碼, 料號原則, 語言, 品名) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'English', N'" & 物料資料庫.品名2_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫新增_語轉3()
        ConnOpen() : SQL1 = "INSERT INTO 物料編碼庫轉語言 (群組碼, 料號原則, 語言, 品名) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'Indonesian', N'" & 物料資料庫.品名3_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫新增_語轉4()
        ConnOpen() : SQL1 = "INSERT INTO 物料編碼庫轉語言 (群組碼, 料號原則, 語言, 品名) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA11 & "', N'" & PA5 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔1()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫 SET 料號原則 = N'" & PA1 & "',原則說明 = N'" & PA2 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔2()
        ConnOpen() : SQL1 = "UPDATE 物料資訊控制表 SET 料號原則 = N'" & PA1 & "',品名 = N'" & PA2 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔3()
        ConnOpen() : SQL1 = "UPDATE 物料圖庫 SET 料號原則 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔4()
        ConnOpen() : SQL1 = "UPDATE 物料規格表 SET 料號原則 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔5()
        ConnOpen() : SQL1 = "UPDATE 採購單明細表 SET 料號原則 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔6()
        ConnOpen() : SQL1 = "UPDATE 請購單明細表 SET 群組原則 = N'" & PA1 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 群組原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔_語轉1()
        ConnOpen()
        SQL1 = "UPDATE 物料編碼庫轉語言 SET 料號原則 = N'" & PA2 & "',品名 = N'" & 物料資料庫.品名1_tb.Text & "' 
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "' AND 語言 LIKE N'繁體中文'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔_語轉2()
        ConnOpen()
        SQL1 = "UPDATE 物料編碼庫轉語言 SET 料號原則 = N'" & PA2 & "',品名 = N'" & 物料資料庫.品名2_tb.Text & "' 
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "' AND 語言 LIKE N'English'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_修改品名後存檔_語轉3()
        ConnOpen()
        SQL1 = "UPDATE 物料編碼庫轉語言 SET 料號原則 = N'" & PA2 & "',品名 = N'" & 物料資料庫.品名3_tb.Text & "' 
                WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "' AND 語言 LIKE N'Indonesian'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料編碼庫_品名修改()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫 SET 原則說明 = N'" & PA2 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資訊控制表_品名修改()
        ConnOpen() : SQL1 = "UPDATE 物料資訊控制表 SET 品名 = N'" & PA2 & "' WHERE 群組碼 LIKE N'" & PA3 & "' AND 料號原則 LIKE N'" & PA4 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料編碼庫_單位修改()
        ConnOpen() : SQL1 = "UPDATE 物料編碼庫 SET  單位 = N'" & PA1 & "' WHERE (群組碼  LIKE N'" & PA2 & "' AND 料號原則 LIKE N'" & PA3 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料編碼庫刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料編碼庫 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表刪除3()
        ConnOpen() : SQL1 = "DELETE FROM 物料資訊控制表 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料規格表刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料規格表 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料圖庫刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料圖庫 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料規格表刪除_語轉()
        ConnOpen() : SQL1 = "DELETE FROM 物料編碼庫轉語言 WHERE 群組碼 LIKE N'" & PA1 & "' AND 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料圖片流水號最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP (1) 圖片流水號 FROM 物料圖庫 ORDER BY 圖片流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_圖檔入系統()
        ConnOpen()
        SQL1 = "INSERT INTO 物料圖庫 (圖片流水號, 群組碼, 料號原則, 版本, 圖檔) SELECT '" & 物料資料庫.圖檔編號_tb.Text & "', '" & 物料資料庫.群組碼1_tb.Text & "', 
                '" & 物料資料庫.物料原則_tb.Text & "', 'V01', @binary_file"
        CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_物料資料庫_圖檔入系統1()
        ConnOpen()
        SQL1 = "INSERT INTO 物料圖庫 (圖片流水號, 群組碼, 料號原則, 版本, 圖檔) SELECT '" & PA20 & "', '" & PA21 & "', '" & PA22 & "', 'V01', @binary_file"
        CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_物料圖庫_圖片版本()
        ConnOpen() : SQL1 = "SELECT 版本 FROM  物料圖庫 WHERE (圖片流水號 = '" & 物料資料庫.圖檔編號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片修改()
        ConnOpen() : SQL1 = "UPDATE 物料圖庫 SET 版本 = '" & PA48 & "', 圖檔 = @binary_file WHERE (圖片流水號 = '" & 物料資料庫.圖檔編號_tb.Text & "')" : CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_物料圖庫_群組圖片版本()
        ConnOpen() : SQL1 = "SELECT 版本 FROM 物料群組 WHERE (群組碼 = '" & 物料資料庫.群組碼_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_群組圖片版本1()
        ConnOpen() : SQL1 = "SELECT 版本, 群組碼 FROM 物料群組 WHERE (群組碼 LIKE '" & PA20 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_群組圖片修改()
        ConnOpen() : SQL1 = "UPDATE 物料群組 SET 版本 = '" & PA48 & "', 圖片 = @binary_file WHERE (群組碼 = '" & 物料資料庫.群組碼_tb.Text & "')" : CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_物料圖庫_群組圖片修改1()
        ConnOpen() : SQL1 = "UPDATE 物料群組 SET 版本 = '" & PA48 & "', 圖片 = @binary_file WHERE (群組碼 = '" & PA20 & "')" : CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_物料資料庫_物料圖庫()
        ConnOpen() : SQL1 = "DELETE FROM 物料圖庫 WHERE (圖片流水號 = N'" & 物料資料庫.圖檔編號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_規格庫抬頭指定重複查詢()
        ConnOpen() : SQL1 = "SELECT 規格庫抬頭指定, A1, A2, A3, A4, A5, A6, A7, A8 FROM 規格庫抬頭 WHERE 規格庫抬頭指定 LIKE N'" & 物料資料庫.規格庫抬頭指定_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_規格庫抬頭指定修改()
        ConnOpen()
        SQL1 = "UPDATE 規格庫抬頭 SET A1 = N'" & 物料資料庫.A1_tb.Text & "', A2 = N'" & 物料資料庫.A2_tb.Text & "', A3 = N'" & 物料資料庫.A3_tb.Text & "', A4 = N'" & 物料資料庫.A4_tb.Text &
               "', A5 = N'" & 物料資料庫.A5_tb.Text & "', A6 = N'" & 物料資料庫.A6_tb.Text & "', A7 = N'" & 物料資料庫.A7_tb.Text & "', A8 = N'" & 物料資料庫.A8_tb.Text & "' 
               WHERE 規格庫抬頭指定 LIKE N'" & 物料資料庫.規格庫抬頭指定_tb.Text & "' AND 語言 LIKE N'" & 物料資料庫.系統語言_cb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_規格庫抬頭指定刪除()
        ConnOpen() : SQL1 = "DELETE FROM 規格庫抬頭 WHERE 規格庫抬頭指定 LIKE N'" & 物料資料庫.規格庫抬頭指定_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表重複查詢()
        SQL1 = "SELECT 群組碼 FROM 物料資訊控制表 
                WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼2_tb.Text & "' AND 料號原則 LIKE N'" & 物料資料庫.物料原則2_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表新增()
        SQL1 = "INSERT INTO 物料資訊控制表 (品名, 群組碼, 料號原則, 規格庫編號, 規格庫抬頭指定) VALUES (N'" & PA6 & "', N'" & PA7 & "', N'" & PA8 & "', N'" & PA9 & "', N'" & PA10 & "')"
    End Sub
    Friend Sub SQL_物料資訊控制表_資訊修改()
        ConnOpen()
        SQL1 = "UPDATE 物料資訊控制表 SET 規格庫編號 = N'" & 物料資料庫.規格庫編號1_cb.Text & "', 規格庫抬頭指定 = N'" & 物料資料庫.規格庫抬頭指定1_cb.Text & "' 
                WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼2_tb.Text & "' AND 料號原則 LIKE N'" & 物料資料庫.物料原則2_tb.Text & "'"
        CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 物料規格表 SET S1 = 1, S2 = 1, S3 = 1, S4 = 1, S5 = 1, S6 = 1, S7 = 1, S8 = 1 WHERE ( 料號原則 LIKE N'" & 物料資料庫.物料原則2_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表刪除()
        SQL1 = "DELETE FROM 物料資訊控制表 WHERE 群組碼 LIKE N'" & 物料資料庫.群組碼2_tb.Text & "', 料號原則 LIKE N'" & 物料資料庫.物料原則2_tb.Text & "', 品名  LIKE N'" & 物料資料庫.原則說明_tb.Text & "'"
    End Sub
    Friend Sub SQL_物料規格表_修改()
        ConnOpen()
        SQL1 = "UPDATE 物料規格表 SET A1 = N'" & PA1 & "', A2 = N'" & PA2 & "', A3 = N'" & PA3 & "', A4 = N'" & PA4 & "', A5 = N'" & PA5 & "', A6 = N'" & PA6 & "', A7 = N'" & PA7 & "', 
                                          A8 = N'" & PA8 & "', 最低庫存量 = N'" & PA9 & "' , 最高庫存量 = N'" & PA10 & "', 排序 = N'" & PA12 & "'
                WHERE (料號  LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_後四碼()
        ConnOpen() : SQL1 = "SELECT TOP (1) RIGHT(料號, 4) AS 後四碼 FROM 物料規格表 WHERE (料號原則 LIKE N'" & PA & "') ORDER BY 料號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_後兩碼()
        ConnOpen() : SQL1 = "SELECT TOP (1) RIGHT(料號, 2) AS 後兩碼 FROM 物料規格表 WHERE (料號原則 LIKE N'" & PA & "') ORDER BY 料號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_料號查詢()
        ConnOpen() : SQL1 = "SELECT 料號 FROM 物料規格表 WHERE (料號 LIKE N'" & PA1 & "-" & PA2 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_料號查詢1()
        ConnOpen() : SQL1 = "SELECT 料號 FROM 物料規格表 WHERE (料號 LIKE N'" & PA2 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 物料規格表 (群組碼, 料號原則, 料號, 圖檔編號, A1, A2, A3, A4, A5, A6, A7, A8, 最低庫存量, 最高庫存量, S1, S2, S3, S4, S5, S6, S7, S8) 
                VALUES (N'" & PA3 & "', N'" & PA4 & "', N'" & PA50 & "', N'', N'" & PA5 & "', N'" & PA6 & "', N'" & PA7 & "', N'" & PA8 & "', N'" & PA9 & "', N'" & PA10 & "', 
                        N'" & PA11 & "', N'" & PA12 & "', N'0', N'0', N'1', N'1', N'1', N'1', N'1', N'1', N'1', N'1')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料規格表 WHERE (料號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_料號修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 料號 = N'" & PA10 & "' WHERE (料號  LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_請購單明細表_料號修改()
        ConnOpen() : SQL1 = "UPDATE 請購單明細表 SET 料號 = N'" & PA10 & "' WHERE (料號  LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購單明細表_料號修改()
        ConnOpen() : SQL1 = "UPDATE 採購單明細表 SET 料號 = N'" & PA10 & "' WHERE (料號  LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_合約試算明細表_料號修改()
        ConnOpen() : SQL1 = "UPDATE 合約試算明細表 SET 料號 = N'" & PA10 & "' WHERE (料號  LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_料號修改()
        ConnOpen() : SQL1 = "UPDATE 物料規格表 SET 料號 = N'" & PA10 & "' WHERE (料號  LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_物料資訊控制表刪除1()
        ConnOpen() : SQL1 = "DELETE FROM 物料規格表 WHERE 料號 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_複製圖檔()
        ConnOpen()
        SQL1 = "INSERT INTO 物料圖庫 (圖片流水號, 圖檔, 群組碼, 料號原則) SELECT '" & PA5 & "' AS 圖片流水號, 圖檔, 群組碼, '" & PA2 & "' AS 料號原則
                FROM        物料圖庫 AS 物料圖庫_1
                WHERE      (圖片流水號 LIKE N'" & PA4 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格表_修改1()
        ConnOpen()
        SQL1 = "UPDATE 物料規格表 SET S1 = N'" & PA1 & "', S2 = N'" & PA2 & "', S3 = N'" & PA3 & "', S4 = N'" & PA4 & "', S5 = N'" & PA5 & "', S6 = N'" & PA6 & "', S7 = N'" & PA7 & "', 
                                          S8 = N'" & PA8 & "' WHERE (料號  LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資訊控制表_規格庫抬頭指定1()
        ConnOpen() : SQL1 = "SELECT 規格庫抬頭指定 FROM 規格庫抬頭 WHERE 規格庫抬頭指定 LIKE 'HE" & PA25 & "%' GROUP BY 規格庫抬頭指定 ORDER BY 規格庫抬頭指定" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_刪除()
        ConnOpen() : SQL1 = "DELETE 物料新群組 WHERE  (編號 LIKE '" & PA10 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_修改_中()
        ConnOpen()
        SQL1 = "UPDATE  物料新群組  SET  第一層 = N'" & PA20 & "', 第二層 = N'" & PA21 & "', 第三層 = N'" & PA22 & "', 第四層 = N'" & PA23 & "', 第五層 = N'" & PA24 & "'
                WHERE  (語言 LIKE '繁體中文') AND (編號 LIKE '" & PA10 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_修改_英()
        ConnOpen()
        SQL1 = "UPDATE  物料新群組  SET  第一層 = N'" & PA20 & "', 第二層 = N'" & PA21 & "', 第三層 = N'" & PA22 & "', 第四層 = N'" & PA23 & "', 第五層 = N'" & PA24 & "'
                WHERE  (語言 LIKE 'English') AND (編號 LIKE '" & PA10 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_修改_印()
        ConnOpen()
        SQL1 = "UPDATE  物料新群組  SET  第一層 = N'" & PA20 & "', 第二層 = N'" & PA21 & "', 第三層 = N'" & PA22 & "', 第四層 = N'" & PA23 & "', 第五層 = N'" & PA24 & "'
                WHERE  (語言 LIKE 'Indonesian') AND (編號 LIKE '" & PA10 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 物料新群組 (編號, 語言, 第一層, 第二層, 第三層, 第四層, 第五層) 
                VALUES (N'" & PA10 & "',N'" & PA11 & "',N'" & PA20 & "',N'" & PA21 & "',N'" & PA22 & "',N'" & PA23 & "',N'" & PA24 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_流水號()
        ConnOpen() : SQL1 = "SELECT  編號  FROM  物料新群組 ORDER BY 編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新物料群組_指定修改()
        ConnOpen() : SQL1 = "UPDATE  物料編碼庫  SET  新群組碼 = N'" & PA20 & "' WHERE  (料號原則 LIKE N'" & PA10 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫_規格庫抬頭指定新增()
        ConnOpen()
        SQL1 = "INSERT INTO 規格庫抬頭 (規格庫抬頭指定, A1, A2, A3, A4, A5, A6, A7, A8, 語言) VALUES (N'" & 物料資料庫.規格庫抬頭指定_tb.Text & "', N'" & 物料資料庫.A1_tb.Text &
               "', N'" & 物料資料庫.A2_tb.Text & "', N'" & 物料資料庫.A3_tb.Text & "', N'" & 物料資料庫.A4_tb.Text & "', N'" & 物料資料庫.A5_tb.Text & "', N'" & 物料資料庫.A6_tb.Text &
               "', N'" & 物料資料庫.A7_tb.Text & "', N'" & 物料資料庫.A8_tb.Text & "' , '" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉名_下拉清單()
        ConnOpen() : SQL1 = "SELECT 倉名 FROM 倉儲分區控制表 WHERE CXL = '0' ORDER BY 倉級, 倉名編號" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_料號原則前二_下拉清單()
        ConnOpen() : SQL1 = "SELECT LEFT(料號原則, 2) AS 原則前二 FROM 物料編碼庫 GROUP BY LEFT(料號原則, 2)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_料號原則中段_下拉清單()
        ConnOpen()
        SQL1 = "SELECT REVERSE(SUBSTRING(REVERSE(SUBSTRING(料號原則, 4, 50)), 6, 50)) AS 原則中段
                FROM 物料編碼庫
                WHERE (LEFT(料號原則, 2) LIKE N'" & PA9 & "')
                GROUP BY   REVERSE(SUBSTRING(REVERSE(SUBSTRING(料號原則, 4, 50)), 6, 50))
                ORDER BY   原則中段"
        CmdSet_For_dr()
    End Sub
    '---------------------倉儲分區控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_倉儲分區控制表_清單()
        ConnOpen() : SQL1 = "SELECT 倉級, 倉名編號, 倉名, CXL FROM 倉儲分區控制表 ORDER BY 倉級, 倉名編號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲分區控制表_最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP(1) 倉名編號 FROM 倉儲分區控制表 ORDER BY 倉名編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_倉名查詢()
        ConnOpen() : SQL1 = "SELECT 倉名編號 FROM 倉儲分區控制表 WHERE 倉名 LIKE N'" & 倉儲分區控制表.倉名_tb.Text & "' AND CXL =  N'" & 倉儲分區控制表.CXL_ch.Checked & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_不重複查詢()
        ConnOpen()
        SQL1 = "SELECT 倉名編號 FROM 倉儲分區控制表 
                WHERE 倉級 LIKE N'" & 倉儲分區控制表.倉級_tb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉名編號_tb.Text & "' AND 
                      倉名 LIKE N'" & 倉儲分區控制表.倉名_tb.Text & "' AND CXL =  N'" & 倉儲分區控制表.CXL_ch.Checked & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 倉儲分區控制表 (倉級, 倉名編號, 倉名, CXL) 
                VALUES (N'" & 倉儲分區控制表.倉級_tb.Text & "',N'" & 倉儲分區控制表.倉名編號_tb.Text & "',N'" & 倉儲分區控制表.倉名_tb.Text & "', '0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_修改()
        ConnOpen()
        SQL1 = "UPDATE 倉儲分區控制表 SET 倉名 = N'" & 倉儲分區控制表.倉名_tb.Text & "', CXL =  N'" & 倉儲分區控制表.CXL_ch.Checked & "'
                WHERE (倉級 LIKE N'" & 倉儲分區控制表.倉級_tb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉名編號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_刪除()
        ConnOpen()
        SQL1 = "DELETE FROM 倉儲分區控制表 
                WHERE 倉級 LIKE N'" & 倉儲分區控制表.倉級_tb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉名編號_tb.Text & "' AND 倉名 LIKE N'" & 倉儲分區控制表.倉名_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_入庫申請無指定()
        ConnOpen()
        SQL1 = "SELECT     倉儲明細表.執行單號, 倉儲分區控制表.倉名, 倉儲明細表.倉級, 倉儲分區控制表.倉級 AS 倉級_1, 倉儲明細表.倉名編號, 倉儲分區控制表.倉名編號 AS 倉名編號_1
                FROM       倉儲明細表 LEFT OUTER JOIN 倉儲分區控制表 ON 倉儲明細表.倉級 = 倉儲分區控制表.倉級 AND 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號
                WHERE     (倉儲明細表.倉庫作業 LIKE N'') AND (倉儲分區控制表.倉名編號 IS NULL)
                GROUP BY   倉儲明細表.執行單號, 倉儲分區控制表.倉名, 倉儲明細表.倉級, 倉儲分區控制表.倉級, 倉儲明細表.倉名編號, 倉儲分區控制表.倉名編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲明細表修正入庫資料()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 倉級 = N'" & PA2 & "', 倉名編號 = N'" & PA3 & "' WHERE (執行單號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料群組_舊1()
        ConnOpen() : SQL1 = "SELECT  編碼, 項目  FROM  物料舊分類  WHERE  (層級 LIKE '1')  ORDER BY  編碼" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料群組_舊2()
        ConnOpen() : SQL1 = "SELECT  編碼, 項目  FROM  物料舊分類  WHERE  (層級 LIKE '2') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料群組_舊3()
        ConnOpen() : SQL1 = "SELECT  編碼, 項目  FROM  物料舊分類  WHERE  (層級 LIKE '3') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料群組_舊4()
        ConnOpen() : SQL1 = "SELECT  編碼, 項目  FROM  物料舊分類  WHERE  (層級 LIKE '4') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_查詢群組_舊1()
        ConnOpen() : SQL1 = "SELECT  TOP(1) 編碼  FROM  物料舊分類  WHERE  (層級 LIKE '1')  ORDER BY  編碼 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢群組_舊2()
        ConnOpen() : SQL1 = "SELECT  TOP(1) 編碼  FROM  物料舊分類  WHERE  (層級 LIKE '2') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢群組_舊3()
        ConnOpen() : SQL1 = "SELECT  TOP(1) 編碼  FROM  物料舊分類  WHERE  (層級 LIKE '3') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢群組_舊4()
        ConnOpen() : SQL1 = "SELECT  TOP(1) 編碼  FROM  物料舊分類  WHERE  (層級 LIKE '4') AND (編碼 LIKE '" & PA10 & "%')  ORDER BY  編碼 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_舊群組_新增()
        ConnOpen() : SQL1 = "INSERT INTO 物料舊分類 (編碼, 項目, 層級) VALUES (N'" & PA12 & "',N'" & PA11 & "',N'" & PA13 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_舊群組_修改()
        ConnOpen() : SQL1 = "UPDATE 物料舊分類 SET 項目 = N'" & PA11 & "' WHERE 編碼 LIKE N'" & PA12 & "'" : CmdSet_For_dr()
    End Sub
End Module
